#include <qapplication.h>
#include "UmlCom.h"
#include "UmlItem.h"

#define VERSION "0.7"

// the program is called with the socket port number in argument
// Arg 1 (Optional): = 'gf', an abbreviation for global fixture
// Arg 2 (Arg 1 if 'gf' is not specified): Port to connect
int main(int argc, char ** argv)
{
  if (argc > 3) return -1;

  QApplication a(argc, argv);

  if (UmlCom::connect(QString(argv[argc-1]).toUInt())) {
    UmlCom::trace(QCString("<b>GenCxxTests plugout version ") + QCString(VERSION) + "</b><hr>" );
    try {
      // Generate the CxxTestCase class for the selected class in browser
      // operation exist at UmlItem level (and probably sub_level !)
      if( argc == 3 && QCString(argv[1]) == "gf" ){
        UmlCom::targetItem()->genGlobalFixture();
      } else {
        UmlCom::targetItem()->genCxxTestCase();
      }
    }
    catch (...) {
	UmlCom::trace("Error: an exception has occured.");
    }

    UmlCom::trace("Done.");

    // must be called to cleanly inform that all is done
    UmlCom::bye();
  }
  
  UmlCom::close();
  return 0;
}
