
#include "UmlCom.h"
#include "UmlArtifact.h"
#include "UmlDeploymentView.h"
#include "UmlClass.h"

UmlArtifact* UmlArtifact::genTestArtifact(UmlDeploymentView * dv, UmlClass * newClass)
{
  QCString strArtifactName = "AllTests";
  UmlArtifact* artifact = dv->getArtifact( strArtifactName  );
  
  if( ! artifact ){
  	artifact = UmlArtifact::create(dv, strArtifactName );
  	if(!artifact){
  		UmlCom::trace("could not generate source artifact for " + newClass->name());
  		return (UmlArtifact*)0;
  	}
  }
  
  artifact->set_Stereotype("source");
  artifact->addAssociatedClass(newClass);
  
  QCString hdrDefinition = "#ifndef ${NAMESPACE}_${NAME}_H\n";
  hdrDefinition += "#define ${NAMESPACE}_${NAME}_H\n\n";
  hdrDefinition += "${comment}\n";
  
  QCString val;
  
  hdrDefinition += "#include <cxxtest/TestSuite.h>\n";
  
  if( newClass->propertyValue("CxxTestGlobalFixture", val) ){
  	hdrDefinition += "#include <cxxtest/GlobalFixture.h>\n";
  }
  
  // Generate includes of all classes-under-test
  //QVector<UmlClass> ac = artifact->associatedClasses();
  //for(i=0; i < ac.size(); i++){
  //	UmlClass* cls = ac[i];
  //	hdrDefinition += "#include \"" + cls->name() + ".h\"\n";					
  //}
  hdrDefinition += "${includes}\n";
  hdrDefinition += "${declarations}\n";
  hdrDefinition += "${namespace_start}\n";
  hdrDefinition += "${definition}\n";
  hdrDefinition += "${namespace_end}\n";
  hdrDefinition += "#endif\n";
  		
  artifact->set_CppHeader(hdrDefinition);
  artifact->set_CppSource(""); // don't generate source file
  
  return artifact;
}

