#ifndef _UMLCLASS_H
#define _UMLCLASS_H


#include "UmlBaseClass.h"
#include <qcstring.h>

class UmlOperation;
class UmlAttribute;
class UmlClassView;
class UmlDeploymentView;

// This class manages 'classes', notes that the class 'ClassItem'
// is a mother class of the class's children.
//
// You can modify it as you want (except the constructor)
class UmlClass : public UmlBaseClass {
  public:
    UmlClass(void * id, const QCString & n) : UmlBaseClass(id, n) {};

    //Generate a CxxTestCase derived class for the selected class in browser
    void genCxxTestCase();

    //Generate the test class members
    void genTestClassMembers(UmlClass * newClass);

    //Generate the test class members
    void genEnumTraits(UmlClass * newClass);

    UmlOperation* getOperation(QCString who);

    UmlAttribute* getAttribute(QCString who);


  protected:
    bool bEnum;

    bool bGenFixture;

    //The classview to use for generating tests
    UmlClassView* cv;

    //The deployment view to use for generating test artifacts
    UmlDeploymentView* dv;

};

#endif
