
#include "UserInput.h"
#include "UmlItem.h"

#include <qcombobox.h>
#include <qcheckbox.h>
#include "UmlCom.h"
#include "frmgencxxtest.h"
UserInput::UserInput() : classViewsFound(20), deploymentViewsFound(20){
bSearched = false;
bViewsSelected = false;
bGenFixture = false;
selectedClassView = 0;
selectedDeploymentView = 0;
bWorldFixtureCheckBox = false;
}

UserInput::~UserInput(){

if(instance != 0) {
	delete instance;
	instance = 0;
}
}

UserInput * UserInput::instance = 0;

bool UserInput::getUserInput() {
if(bSearched && !bViewsSelected){
	return false; // selection data not available
}

if(!bSearched){
	UmlCom::trace("searching for class views ... ");
	UmlItem::searchForAll(aClassView, classViewsFound);

	UmlCom::trace("searching for deployment views ... ");
	UmlItem::searchForAll(aDeploymentView, deploymentViewsFound);

	UmlCom::trace("search complete ");
	bSearched = true;
}

if(!bViewsSelected){
	// display the dialog
	FrmGenCxxTest dlg(0, 0, TRUE);
	dlg.setViews(classViewsFound, deploymentViewsFound);
	//dlg.chkGenFixture->setDisabled(bDisableFixtureCheckBox);
	if(bWorldFixtureCheckBox)
		dlg.chkGenFixture->setText("Generate World Fixture");

	if(dlg.exec() == QDialog::Accepted){
		bGenFixture = dlg.chkGenFixture->isChecked();
		selectedClassView = dlg.cboClassView->currentItem();
		selectedDeploymentView = dlg.cboDeploymentView->currentItem();
		bViewsSelected = true;
		return true;
	}

	bGenFixture = false;
	selectedClassView = 0;
	selectedDeploymentView = 0;

	return false;
}

// don't change the previous selected views, 
// just indicate that the data is available
return true;
}

