#ifndef _USERINPUT_H
#define _USERINPUT_H


#include <qvector.h>
#include "UmlClassView.h"
#include "UmlDeploymentView.h"

class UmlItem;

class UserInput {
  private:
    UserInput();

  public:
    ~UserInput();

  protected:
    static UserInput * instance;


  public:
    static inline UserInput * get_instance();
    //Boolean value indicating if the "Generate Fixture Checkbox should be disabled when the dialog is shown"
    //This is used when generating global fixtures
    bool bWorldFixtureCheckBox;


  protected:
    //have we already selected the class and deployment views on the dialog box
    bool bViewsSelected;

    //have we already searched the model for all class and deployment
    bool bSearched;


  private:
    QVector<UmlItem> classViewsFound;

    QVector<UmlItem> deploymentViewsFound;

    int selectedClassView;

    int selectedDeploymentView;

    bool bGenFixture;


  public:
    UmlClassView* get_selectedClassView() const;

    UmlDeploymentView* get_selectedDeploymentView() const;

    bool get_bGenFixture() const;

    //Return TRUE if user pressed Generate on the dialog box, FALSE otherwise.
    bool getUserInput();
};

inline UserInput * UserInput::get_instance()
{
  if (instance == 0) instance = new UserInput();
  return instance;
}

inline UmlClassView* UserInput::get_selectedClassView() const {
  return (UmlClassView*)classViewsFound[selectedClassView];
}

inline UmlDeploymentView* UserInput::get_selectedDeploymentView() const {
  return (UmlDeploymentView*)deploymentViewsFound[selectedDeploymentView];
}

inline bool UserInput::get_bGenFixture() const {
  return bGenFixture;
}

#endif
